#include "ptask.h"
#include <stdio.h>

// hello world sample code
// Peter Walsh csci 461

#define T1CORE 0
#define T2CORE 0

ptask taskbody() {
    ptask_wait_for_activation();
    while (1) {
        printf("Task T%d is running Hello World \n", ptask_get_index());
        ptask_wait_for_period();
    }
}

int main() {
    tpars param1, param2;
    int t1, t2;
    int num;

    ptask_init(SCHED_RR, PARTITIONED, PRIO_INHERITANCE);

    ptask_param_init(param1);              
    ptask_param_period(param1, 1, SEC);  
    ptask_param_deadline(param1, 1, SEC); 
    ptask_param_priority(param1, 4);   
    ptask_param_processor(param1, T1CORE);     
    t1 = ptask_create_param(taskbody, &param1);
    printf("Creation of task: %d\n", t1);

    ptask_param_init(param2);              
    ptask_param_period(param2, 1, SEC);  
    ptask_param_deadline(param2, 1, SEC); 
    ptask_param_priority(param2, 6);   
    ptask_param_processor(param2, T2CORE);     
    t2 = ptask_create_param(taskbody, &param2);
    printf("Creation of task: %d\n", t2);

    num = ptask_getnumcores();
    printf("Num cores: %d\n", num);

    ptask_activate(t1);
    printf("Activation of task: %d\n", t1);

    ptask_activate(t2);
    printf("Activation of task: %d\n", t2);

    while (1) {
       usleep(100000); 
    }

    return 0;
}
